100 ''''''''''''''''''''''''''''''''''''''''''''
110 ' GRAPH48.BAS
120 ' Demonstration program showing the ability
130 ' to graph and display BMS data.
140 ' Cell voltages are simulated with
150 ' random numbers.
160 '
170 '''''''''''''''''''''''''''''''''''''''''''
180 '
190 DIM barval(48)
200 DIM cellV(48)
210 CLS
220 width = MM.HRES - margin
230 height = 100
240 margin = 10
250 '
260 ' parameters for the bar graphs
270 bx = margin : by = MM.VRES-10
280 dx = bx : dy = by
290 GOSUB 620 ' draw the axies for the bar graph
300 '
310 TIME$ = "0:0:0" ' Zero the clock
320 FONT 2
330 '
340 HiV=0 : LoV=5 : PackV=0
350 FOR I = 1 TO 48
360 ' Generate random cell voltage values
370  cellV(I) = RND()+2.5
380 IF CellV(I) < LoV THEN 
390 LoV = CellV(I) : LoCell = I : ENDIF
400 IF CellV(I) > HiV THEN
410 HiV = CellV(I) : HiCell = I : ENDIF
420 PackV = PackV + CellV(I)
430 NEXT i
440 LOCATE 0,0
450 ' Display cell and pack values
460 PRINT FORMAT$(PackV," Pack %4.1fV   ")TIME$
470 PRINT " High cell "FORMAT$(HiCell,"[%2.0f]");
480 PRINT "    "FORMAT$(HiV,"%3.2f")
490 PRINT "  Low cell "FORMAT$(LoCell,"[%2.0f]");
500 PRINT "    "FORMAT$(LoV,"%3.2f")
510 ''''''''''draw the bar graphs''''''''''
520 FOR j = 1 TO 48
530  barval(j) = (cellV(J)-2)*50
540  st = 6*(j - 1) + bx
550  LINE(st,by)-(st+3,by-barval(j)),1,bf
560  LINE (st,by-barval(j))-(st+3,by-height),0,bf
570 NEXT j
580 IF INKEY$="S" THEN SAVEBMP "image1"
590  PAUSE 200
600 GOTO 340
610 '
620 '''' Subroutine to draw the graph axies '''''
630 'CLS
640 LINE (dx,dy)-(dx, dy - height), 1 
650 ' Draw the vert line
660 LINE (dx,dy)-(dx + Width ,dy), 1  
670 ' Draw the horiz line
680 FOR i=0 TO 33 'This loop draws the tick marks
690  h = dy - (height / 33) * i
700  t = dx - 5
710  IF i MOD 5 = 0 THEN t = dx-8  
720  ' Longer tick mark if unit of 0.5V
730  IF i MOD 10 = 0 THEN 
740  ' Special mark for a unit of 1V
750    LOCATE dx - 42, h - 3
760    PRINT LEFT$(FORMAT$(i/10,"%f"),3);"V"; 
770    ' Label the tick mark
780    t = dx - 15
790   ENDIF
800  LINE (dx, h)-(t, h), 1
810  ' Draw the tick mark
820 NEXT i
830 RETURN
